
sjis	= {}

local string	= string
local sub	= string.sub
local slen	= string.len
local byte	= string.byte
local char	= string.char
local insert	= table.insert



--------------------------------------------------
-- 1oCge[u
--------------------------------------------------
local tbyte	= {}
--for b=0,0xff do
--	tbyte[b+1]	= ( (b>=0x81 and b<=0x9f) or (b>=0xE0 and b<=0xFC) )
--end
for b=0x00,0xff do	tbyte[b+1]	= false	end	-- RgAEgƂƂĂ͂₢I
for b=0x81,0x9f do	tbyte[b+1]	= true	end
for b=0xe0,0xfc do	tbyte[b+1]	= true	end

sjis.table	= tbyte



--------------------------------------------------
-- ꉞmainIȂƂ
--------------------------------------------------
function sjis.str(s)
	local l		= slen(s)

	local st	= { byte(s,1,l) }
	local t		= {}

	local i		= 1
	local n		= 1

	while(i<=l)do
		local c	= st[i]
		if( tbyte[c+1] )then	-- 2oCg
			t[n]	= {
				char	= char(st[i],st[i+1]),
				num	= st[i]*256+st[i+1],
				byte	= 2
			}
		else			-- 1oCg
			t[n]	= {
				char	= char(st[i]),
				num	= st[i],
				byte	= 1
			}
		end

		i	= i+t[n].byte
		n	= n+1
	end

	return t
end



--------------------------------------------------
-- ֕
--------------------------------------------------
function sjis.tostring(t)
	if(t==nil)then	return nil end

	local str	= ""

	for i=1,#t do
		local s	= t[i].char
		if(s==nil)then
			local n	= t[i].num
			if(n==nil)then	break end

			local l	= {}
			while(n>0)do
				insert( l,1,AND(n,0xff) )
				n	= SHIFT(n,-8)
			end
			s	= string.char( unpack(l) )
		end

		str	= str..s
	end

	return str
end





--------------------------------------------------
-- Ղ
--------------------------------------------------

--[[
str = "hoge"
t = sjis.str(str)

for i=1,#t do
	mes( string.format("[%2d] %-2s : 0x%04x %d\n",i,t[i].char,t[i].num, t[i].byte) )
end

]]


